/***********************************
    Created By : Beycan Kahraman
************************************/

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

using namespace std;

#define 	MAX_NAME	64
#define 	MAX_POET	130
#define 	MAX_PRIME	10
#define 	MAX_HASH	200
#define 	MAX_CHAR 	20000

typedef struct hash_node{
	int 	ptr;
	char 	name[MAX_NAME];
}Node;

typedef struct hash_table{
	Node 	node[MAX_HASH];
	bool 	used[MAX_HASH];
}Table;

typedef struct tmp_table{
	Node 	node[MAX_POET];
}Tmp;

int toDecimal(int n){
	if(n == 0)
		return 0;
	return 1 + toDecimal(n/10);
}

bool ReadData(Tmp *tmp){
	cout << "---------------------------------------------------------" << endl;
	cout << " Reading All The Poets From Database..." << endl;
	FILE *f;
	int n = 0, length, total = 0;
	int i;
	char name[MAX_CHAR];
	if(f = fopen("database.txt","r")){
		for(int j=0; j<MAX_POET; j++){
			fscanf(f, "%d", &length);
			total += length + toDecimal(length);
			if(feof(f))
				break;
			for(i = 0; i<length; i++)
				fscanf(f, "%c", &name[i]);
			name[i] = '\0';
			(*tmp).node[j].ptr = total;
			strcpy((*tmp).node[j].name, name);
			
			fscanf(f, "%d", &length);
			total += length + toDecimal(length);
			for(i = 0; i<length; i++){
				fscanf(f, "%c", &name[i]);
				if(name[i] == '\n') i++;
			}
			n++;
		}
		fclose(f);
		return true;
	}else
		return false;
}

void PrintTmpData(Tmp *tmp){
	cout << "---------------------------------------------------------" << endl;
	for(int i=0; i<MAX_POET; i++){
		cout << i+1 << "\t:\t" << (*tmp).node[i].ptr << "\t" << (*tmp).node[i].name << endl;
	}
	cout << "---------------------------------------------------------" << endl;
}

void FindMinLinearHash(Table *table, Tmp *tmp, int prime[], int lin[]){
	cout << " Finding The Best Linear Hashing...";
	int i, j, k, n, m, w;
	int node, strlength, collision;
	int ti, tj, tk, tmin = 1000;
	for(i = 0; i < MAX_PRIME; i++)
		for(j = 0; j < MAX_PRIME; j++)
			for(k = 0; k < MAX_PRIME; k++){
				ti = prime[i];
				tj = prime[j]; 
				tk = prime[k];
				collision = 0;
				for(n = 0; n < MAX_HASH; n++)
					(*table).used[n] = false;
				for(n = 0; n < MAX_POET; n++){
					node = 0;
					strlength = strlen((*tmp).node[n].name);
					for(m = 0; m < strlength; m++)
						node += ((ti*((int)((*tmp).node[n].name[m])) + (m+1)*tj)%tk)%MAX_HASH;
					node %= MAX_HASH;
					w = 0;
					while(((*table).used[node])){
						w++;
						if(w > MAX_HASH){
							collision = MAX_HASH;
							break;
						}
						node = (node + 1) % MAX_HASH;
						collision++;
					}
					(*table).node[node].ptr = (*tmp).node[n].ptr;
					(*table).used[node] = true;
					strcpy((*table).node[node].name, (*tmp).node[n].name);
				}
				if( collision < tmin ){
					lin[0] 	= ti;
					lin[1] 	= tj;
					lin[2] 	= tk;
					tmin	= collision;
				}
			}
	collision = 0;
	for(n = 0; n < MAX_HASH; n++)
		(*table).used[n] = false;
	for(n = 0; n < MAX_POET; n++){
		node = 0;
		strlength = strlen((*tmp).node[n].name);
		for(m = 0; m < strlength; m++){
			node += ((lin[0]*((int)((*tmp).node[n].name[m])) + (m+1)*lin[1])%lin[2])%MAX_HASH;
		}
		node %= MAX_HASH;
		while(((*table).used[node])){
			node = (node + 1) % MAX_HASH;
			collision++;
		}
		(*table).node[node].ptr = (*tmp).node[n].ptr;
		(*table).used[node] = true;
		strcpy((*table).node[node].name, (*tmp).node[n].name);
	}
	cout << "    ( " << tmin << " collisions )";
	cout << endl << "---------------------------------------------------------" << endl;
}

void FindMinQuadraticHash(Table *table, Tmp *tmp, int prime[], int qua[]){
	cout << " Finding The Best Quadratic Hashing...";
	int i, j, k, p, l, n, m, w;
	int node, strlength, collision;
	int ti, tj, tk, ts, tt, tmin = 1000;
	for(i = 0; i < MAX_PRIME; i++)
	  for(j = 0; j < MAX_PRIME; j++)
	    for(k = 0; k < MAX_PRIME; k++)
	      for(p = 0; p < MAX_PRIME; p++)
			for(l = 0; l < MAX_PRIME; l++){
				ti = prime[i];
				tj = prime[j];
				tk = prime[k];
				ts = prime[p];
				tt = prime[l];
				collision = 0;
				for(n = 0; n < MAX_HASH; n++)
					(*table).used[n] = false;
				
				for(n = 0; n < MAX_POET; n++){
					node = 0;
					strlength = strlen((*tmp).node[n].name);
					for(m = 0; m < strlength; m++)
						node += ((ti*((int)((*tmp).node[n].name[m])) + (m+1)*tj)%tk)%MAX_HASH;
					node %= MAX_HASH;
					w = 0;
					while(((*table).used[node])){
						w++;
						if(w > MAX_HASH){
							collision = MAX_HASH;
							break;
						}
						node = (node + ts*w + ts*w*w) % MAX_HASH;
						collision++;
					}
					(*table).node[node].ptr = (*tmp).node[n].ptr;
					(*table).used[node] = true;
					strcpy((*table).node[node].name, (*tmp).node[n].name);
				}
				if( collision < tmin ){
					qua[0] 	= ti;
					qua[1] 	= tj;
					qua[2] 	= tk;
					qua[3] 	= ts;
					qua[4] 	= tt;
					tmin	= collision;
				}
			}
	collision = 0;
	for(n = 0; n < MAX_HASH; n++)
		(*table).used[n] = false;
		
	for(n = 0; n < MAX_POET; n++){
		node = 0;
		strlength = strlen((*tmp).node[n].name);
		for(m = 0; m < strlength; m++)
			node += ((qua[0]*((int)((*tmp).node[n].name[m])) + (m+1)*qua[1])%qua[2])%MAX_HASH;
		node %= MAX_HASH;
		w = 0;
		while(((*table).used[node])){
			w++;
			node = (node + qua[3]*w + qua[4]*w*w) % MAX_HASH;
			collision++;
		}
		(*table).node[node].ptr = (*tmp).node[n].ptr;
		(*table).used[node] = true;
		strcpy((*table).node[node].name, (*tmp).node[n].name);
	}
	cout << " ( " << tmin << " collisions )";
	cout << endl << "---------------------------------------------------------" << endl;
}

void FindMinDoubleHash(Table *table, Tmp *tmp, int prime[], int dou[]){
	cout << " Finding The Best Double Hashing...";
	int i, j, k, r, s, t, n, m, w;
	int node, strlength, collision;
	int ti, tj, tk, tr, ts, tt, tmin = 1000;
	for(i = 0; i < MAX_PRIME; i++)
	  for(j = i+1; j < MAX_PRIME; j++)
		for(k = j+1; k < MAX_PRIME; k++)
		  for(r = 0; r < MAX_PRIME; r++)
		    for(s = 0; s < MAX_PRIME; s++)
			  for(t = 0; t < MAX_PRIME; t++){
				ti = prime[i];
				tj = prime[j]; 
				tk = prime[k];
				tr = prime[r];
				ts = prime[s];
				tt = prime[t];
				collision = 0;
				for(n = 0; n < MAX_HASH; n++)
					(*table).used[n] = false;
				
				for(n = 0; n < MAX_POET; n++){
					node = 0;
					strlength = strlen((*tmp).node[n].name);
					for(m = 0; m < strlength; m++)
						node += ((tr*((int)((*tmp).node[n].name[m])) + (m+1)*ts)%tt)%MAX_HASH;
					node %= MAX_HASH;
					w = 0;
					while(((*table).used[node])){
						w++;
						if(w > MAX_HASH){
							collision = MAX_HASH;
							break;
						}
						node += (w*((ti*((int)((*tmp).node[n].name[m])) + (w+1)*tj)%tk))%MAX_HASH;
						collision++;
					}
					node %= MAX_HASH;
					(*table).node[node].ptr = (*tmp).node[n].ptr;
					(*table).used[node] = true;
					strcpy((*table).node[node].name, (*tmp).node[n].name);
				}
				if( collision < tmin ){
					dou[0] 	= tr;
					dou[1] 	= ts;
					dou[2] 	= tt;
					dou[3] 	= ti;
					dou[4] 	= tj;
					dou[5] 	= tk;
					tmin	= collision;
				}
			}
	collision = 0;
	for(n = 0; n < MAX_HASH; n++)
		(*table).used[n] = false;
		
	for(n = 0; n < MAX_POET; n++){
		node = 0;
		strlength = strlen((*tmp).node[n].name);
		for(m = 0; m < strlength; m++)
			node += ((dou[0]*((int)((*tmp).node[n].name[m])) + (m+1)*dou[1])%dou[2])%MAX_HASH;
		node %= MAX_HASH;
		w = 0;
		while(((*table).used[node])){
			w++;
			node += (w*((dou[3]*((int)((*tmp).node[n].name[m])) + (w+1)*dou[4])%dou[5]))%MAX_HASH;
			collision++;
		}
		node %= MAX_HASH;
		(*table).node[node].ptr = (*tmp).node[n].ptr;
		(*table).used[node] = true;
		strcpy((*table).node[node].name, (*tmp).node[n].name);
	}
	cout << "    ( " << tmin << " collisions )";
	cout << endl << "---------------------------------------------------------" << endl;
}

int main(){
	int p[] = { 251, 257, 263, 269, 271, 277, 281, 283, 289, 293, 307, 311, 313, 317, 331, 
				337, 347, 349, 353, 359, 361, 367, 373, 379, 383, 389, 397, 401, 409, 419};
	int MyLinear[3] = {0},  MyQuadratic[5] = {0}, MyDouble[6] = {0};
	
	Table 		table;
	Tmp 		tmp;
	
	int collision, rnd;
	int Inserted[MAX_HASH] = {0};
	
	if(!ReadData(&tmp)){
		cout << "database.txt Could Not Be Found..." << endl;
		system("PAUSE");
		return -1;
	}
	PrintTmpData(&tmp);
	FindMinLinearHash(&table, &tmp, p, MyLinear);
	FindMinQuadraticHash(&table, &tmp, p, MyQuadratic);
	FindMinDoubleHash(&table, &tmp, p, MyDouble);
	
	cout << "---------------------------------------------------------" << endl;
	cout << "  Linear    ( " << MyLinear[0] << ", " << MyLinear[1] << ", " << MyLinear[2] << " )" << endl;
	cout << "  Quadratic ( " << MyQuadratic[0] << ", " << MyQuadratic[1] << ", " << MyQuadratic[2] << ", " << MyQuadratic[3] << ", " << MyQuadratic[4] << " )" << endl;
	cout << "  Double    ( " << MyDouble[0] << ", " << MyDouble[1] << ", " << MyDouble[2] << ", " << MyDouble[3] << ", " << MyDouble[4] << ", " << MyDouble[5] << " )" << endl;
	cout << "---------------------------------------------------------" << endl;
	
	cout << endl;
    system("PAUSE");
    return 0;
}
